Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 16240)
@@ -23,5 +23,4 @@
 using System.ComponentModel;
 using System.Linq;
-using System.Text;
 using System.Threading;
 using System.Threading.Tasks;
@@ -34,4 +33,5 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.PluginInfrastructure;
+using System.Collections.Generic;
 
 namespace HeuristicLab.Clients.Hive.JobManager.Views {
@@ -45,8 +45,12 @@
     private bool SuppressEvents { get; set; }
     private object runCollectionViewLocker = new object();
+    private Project selectedProject;
+    private Dictionary<Guid, Guid> originalJobProjectAssignment = new Dictionary<Guid, Guid>();
 
     public new RefreshableJob Content {
       get { return (RefreshableJob)base.Content; }
-      set { base.Content = value; }
+      set {
+        base.Content = value;
+      }
     }
 
@@ -117,6 +121,7 @@
         if (Content == null) {
           nameTextBox.Text = string.Empty;
+          descriptionTextBox.Text = string.Empty;
           executionTimeTextBox.Text = string.Empty;
-          resourceNamesTextBox.Text = string.Empty;
+          projectNameTextBox.Text = string.Empty;
           refreshAutomaticallyCheckBox.Checked = false;
           lock (runCollectionViewLocker) {
@@ -128,8 +133,75 @@
           stateLogViewHost.Content = null;
         } else {
+          if(Content.Job != null 
+            && Content.Job.Id != Guid.Empty 
+            && !originalJobProjectAssignment.ContainsKey(Content.Job.Id)) {
+            originalJobProjectAssignment.Add(Content.Job.Id, Content.Job.ProjectId);
+          }
+
+          // project look up
+          if (Content.Job != null && Content.Job.ProjectId == Guid.Empty) {
+            projectNameTextBox.Text = string.Empty;
+            if (HiveClient.Instance != null && HiveClient.Instance.Projects != null && HiveClient.Instance.Projects.Count == 1) {
+              var p = HiveClient.Instance.Projects.FirstOrDefault();
+              if (p != null && p.Id != Guid.Empty) {
+                hiveResourceSelectorDialog = new HiveResourceSelectorDialog(Content.Job.Id, Content.Job.ProjectId);
+                Content.Job.ProjectId = p.Id;
+                var resources = HiveClient.Instance.GetAvailableResourcesForProject(p.Id).ToList();
+                Content.Job.ResourceIds = resources.Select(x => x.Id).ToList();
+                hiveResourceSelectorDialog.SelectedProjectId = Content.Job.ProjectId;
+                hiveResourceSelectorDialog.SelectedResourceIds = Content.Job.ResourceIds;
+
+                var cores = resources.Union(resources.SelectMany(x => HiveClient.Instance.GetAvailableResourceDescendants(x.Id)))
+                  .OfType<Slave>()
+                  .Distinct()
+                  .Sum(x => x.Cores);
+
+                projectNameTextBox.Text = HiveClient.Instance.GetProjectAncestry(Content.Job.ProjectId);
+                projectNameTextBox.Text += "   (" + (cores.HasValue ? cores.Value.ToString() : "0") + " cores)";
+              }                
+            }
+          } else if (Content.Job != null && Content.Job.ProjectId != Guid.Empty) {
+            if (selectedProject == null || selectedProject.Id != Content.Job.ProjectId) {
+              selectedProject = GetProject(Content.Job.ProjectId);
+              hiveResourceSelectorDialog = null;
+            }
+
+            if(hiveResourceSelectorDialog == null)
+              hiveResourceSelectorDialog = new HiveResourceSelectorDialog(Content.Job.Id, Content.Job.ProjectId);
+
+            if (selectedProject != null) {
+              projectNameTextBox.Text = HiveClient.Instance.GetProjectAncestry(selectedProject.Id);
+            } else {
+              projectNameTextBox.Text = string.Empty;
+            }
+
+            List<Resource> resources = null;
+            if (Content.Job.ResourceIds == null)
+              resources = HiveClient.Instance.GetAssignedResourcesForJob(Content.Job.Id).ToList();
+            else
+              resources = HiveClient.Instance.Resources.Where(x => Content.Job.ResourceIds.Contains(x.Id)).ToList();
+
+            Content.Job.ResourceIds = resources.Select(x => x.Id).ToList();
+            hiveResourceSelectorDialog.SelectedResourceIds = Content.Job.ResourceIds;
+
+            var cores = resources.Union(resources.SelectMany(x => HiveClient.Instance.GetAvailableResourceDescendants(x.Id)))
+              .OfType<Slave>()
+              .Distinct()
+              .Sum(x => x.Cores);
+
+            projectNameTextBox.Text += "   (" + (cores.HasValue ? cores.Value.ToString() : "0") + " cores)";
+
+          } else {
+            selectedProject = null;
+            projectNameTextBox.Text = string.Empty;
+            Content.Job.ResourceIds = null;
+          }
+
+
           nameTextBox.Text = Content.Job.Name;
+          descriptionTextBox.Text = Content.Job.Description;
           executionTimeTextBox.Text = Content.ExecutionTime.ToString();
-          resourceNamesTextBox.Text = Content.Job.ResourceNames;
           refreshAutomaticallyCheckBox.Checked = Content.RefreshAutomatically;
+          
           logView.Content = Content.Log;
           lock (runCollectionViewLocker) {
@@ -137,9 +209,8 @@
           }
         }
-      }
-      finally {
+      } finally {
         SuppressEvents = false;
       }
-      hiveExperimentPermissionListView.Content = null; // has to be filled by refresh button
+      hiveExperimentPermissionListView.Content = null; // has to be filled by refresh
       Content_JobStatisticsChanged(this, EventArgs.Empty);
       Content_HiveExperimentChanged(this, EventArgs.Empty);
@@ -158,5 +229,6 @@
       tabControl.Enabled = !Locked;
       nameTextBox.Enabled = !Locked;
-      resourceNamesTextBox.Enabled = !Locked;
+      descriptionTextBox.Enabled = !Locked;
+      projectNameTextBox.Enabled = !Locked;
       searchButton.Enabled = !Locked;
       jobsTreeView.Enabled = !Locked;
@@ -182,11 +254,12 @@
           tabControl.Enabled = !Content.IsProgressing;
 
-          this.nameTextBox.ReadOnly = !Content.IsControllable || Content.ExecutionState != ExecutionState.Prepared || alreadyUploaded || Content.IsProgressing;
-          this.resourceNamesTextBox.ReadOnly = !Content.IsControllable || Content.ExecutionState != ExecutionState.Prepared || alreadyUploaded || Content.IsProgressing;
-          this.searchButton.Enabled = Content.IsControllable && Content.ExecutionState == ExecutionState.Prepared && !alreadyUploaded && !Content.IsProgressing;
+          this.nameTextBox.ReadOnly = Content.IsProgressing;
+          this.descriptionTextBox.ReadOnly = Content.IsProgressing;
+          this.searchButton.Enabled = !Content.IsProgressing && Content.ExecutionState != ExecutionState.Stopped;
           this.jobsTreeView.ReadOnly = !Content.IsControllable || Content.ExecutionState != ExecutionState.Prepared || alreadyUploaded || Content.IsProgressing;
 
           this.refreshAutomaticallyCheckBox.Enabled = Content.IsControllable && alreadyUploaded && jobsLoaded && (Content.ExecutionState == ExecutionState.Started || Content.ExecutionState == ExecutionState.Paused) && !Content.IsProgressing;
           this.refreshButton.Enabled = Content.IsDownloadable && alreadyUploaded && !Content.IsProgressing;
+          this.updateButton.Enabled = Content.ExecutionState != ExecutionState.Prepared && Content.ExecutionState != ExecutionState.Stopped && !Content.IsProgressing;
 
           this.UnloadButton.Enabled = Content.HiveTasks != null && Content.HiveTasks.Count > 0 && alreadyUploaded && !Content.IsProgressing;
@@ -333,15 +406,49 @@
     #region Control events
     private void searchButton_Click(object sender, EventArgs e) {
-      if (hiveResourceSelectorDialog == null)
-        hiveResourceSelectorDialog = new HiveResourceSelectorDialog();
+      if (hiveResourceSelectorDialog == null) {
+        hiveResourceSelectorDialog = new HiveResourceSelectorDialog(Content.Job.Id, Content.Job.ProjectId);
+      } else if(hiveResourceSelectorDialog.JobId != Content.Job.Id) {
+        hiveResourceSelectorDialog.JobId = Content.Job.Id;
+        hiveResourceSelectorDialog.SelectedProjectId = Content.Job.ProjectId;
+        hiveResourceSelectorDialog.SelectedResourceIds = Content.Job.ResourceIds;
+
+        if (originalJobProjectAssignment.ContainsKey(Content.Job.Id)) {
+          hiveResourceSelectorDialog.ProjectId = originalJobProjectAssignment[Content.Job.Id];
+        } else {
+          hiveResourceSelectorDialog.ProjectId = Guid.Empty;
+        }
+      } else if(hiveResourceSelectorDialog.JobId == Guid.Empty && Content.Job.Id == Guid.Empty) {
+        hiveResourceSelectorDialog.JobId = Content.Job.Id;
+        hiveResourceSelectorDialog.ProjectId = Guid.Empty;
+        hiveResourceSelectorDialog.SelectedProjectId = Content.Job.ProjectId;
+        hiveResourceSelectorDialog.SelectedResourceIds = Content.Job.ResourceIds;
+      } else {
+        hiveResourceSelectorDialog.SelectedProjectId = Content.Job.ProjectId;
+        hiveResourceSelectorDialog.SelectedResourceIds = Content.Job.ResourceIds;
+      }
+
       if (hiveResourceSelectorDialog.ShowDialog(this) == DialogResult.OK) {
-        StringBuilder sb = new StringBuilder();
-        foreach (Resource resource in hiveResourceSelectorDialog.GetSelectedResources()) {
-          sb.Append(resource.Name);
-          sb.Append(";");
-        }
-        resourceNamesTextBox.Text = sb.ToString();
-        if (Content.Job.ResourceNames != resourceNamesTextBox.Text)
-          Content.Job.ResourceNames = resourceNamesTextBox.Text;
+        selectedProject = hiveResourceSelectorDialog.SelectedProject;
+        if(selectedProject != null) {       
+          Content.Job.ProjectId = selectedProject.Id;
+          Content.Job.ResourceIds = hiveResourceSelectorDialog.SelectedResources.Select(x => x.Id).ToList();
+
+          var cores = hiveResourceSelectorDialog.SelectedResources
+            .Union(hiveResourceSelectorDialog.SelectedResources
+              .SelectMany(x => HiveClient.Instance.GetAvailableResourceDescendants(x.Id)))
+            .OfType<Slave>()
+            .Distinct()
+            .Sum(x => x.Cores);
+
+          projectNameTextBox.Text = HiveClient.Instance.GetProjectAncestry(selectedProject.Id) + "";
+          projectNameTextBox.Text += "   (" + (cores.HasValue ? cores.Value.ToString() : "0") + " cores)";
+
+        } else {
+          selectedProject = null;
+          projectNameTextBox.Text = string.Empty;
+          Content.Job.ProjectId = Guid.Empty;
+          Content.Job.ResourceIds = null;
+        }
+        SetEnabledStateOfExecutableButtons();
       }
     }
@@ -350,4 +457,8 @@
       if (nameTextBox.Text.Trim() == string.Empty) {
         MessageBox.Show("Please enter a name for the job before uploading it!", "HeuristicLab Hive Job Manager", MessageBoxButtons.OK, MessageBoxIcon.Information);
+      } else if (Content.Job.ProjectId == null || Content.Job.ProjectId == Guid.Empty) {
+        MessageBox.Show("Please select a project before uploading the job!", "HeuristicLab Hive Job Manager", MessageBoxButtons.OK, MessageBoxIcon.Information);
+      } else if (Content.Job.ResourceIds == null || !Content.Job.ResourceIds.Any()) {
+        MessageBox.Show("Please select resources before uploading the job!", "HeuristicLab Hive Job Manager", MessageBoxButtons.OK, MessageBoxIcon.Information);
       } else if (Content.ExecutionState == ExecutionState.Paused) {
         var task = System.Threading.Tasks.Task.Factory.StartNew(ResumeJobAsync, Content);
@@ -359,4 +470,5 @@
       } else {
         HiveClient.StartJob((Exception ex) => ErrorHandling.ShowErrorDialog(this, "Start failed.", ex), Content, new CancellationToken());
+        UpdateSelectorDialog();
       }
     }
@@ -403,7 +515,12 @@
     }
 
+    private void descriptionTextBox_Validated(object sender, EventArgs e) {
+      if (!SuppressEvents && Content.Job != null && Content.Job.Description != descriptionTextBox.Text)
+        Content.Job.Description = descriptionTextBox.Text;
+    }
+
     private void resourceNamesTextBox_Validated(object sender, EventArgs e) {
-      if (!SuppressEvents && Content.Job != null && Content.Job.ResourceNames != resourceNamesTextBox.Text)
-        Content.Job.ResourceNames = resourceNamesTextBox.Text;
+      //if (!SuppressEvents && Content.Job != null && Content.Job.ResourceNames != resourceNamesTextBox.Text)
+      //  Content.Job.ResourceNames = resourceNamesTextBox.Text;
     }
 
@@ -417,102 +534,26 @@
         try {
           invoker.EndInvoke(ar);
-        }
-        catch (Exception ex) {
-          ThreadPool.QueueUserWorkItem(delegate(object exception) { ErrorHandling.ShowErrorDialog(this, (Exception)exception); }, ex);
+        } catch (Exception ex) {
+          ThreadPool.QueueUserWorkItem(delegate (object exception) { ErrorHandling.ShowErrorDialog(this, (Exception)exception); }, ex);
         }
       }, null);
-    }
-
-    private void refreshPermissionsButton_Click(object sender, EventArgs e) {
-      if (this.Content.Job.Id == Guid.Empty) {
-        MessageBox.Show("You have to upload the Job first before you can share it.", "HeuristicLab Hive Job Manager", MessageBoxButtons.OK, MessageBoxIcon.Information);
-      } else {
-        hiveExperimentPermissionListView.Content = HiveClient.GetJobPermissions(this.Content.Job.Id);
-      }
-    }
-    #endregion
-
-    #region Helpers
-    private void SetEnabledStateOfExecutableButtons() {
-      if (Content == null) {
-        startButton.Enabled = pauseButton.Enabled = stopButton.Enabled = false;
-      } else {
-        startButton.Enabled = Content.IsControllable && Content.HiveTasks != null && Content.HiveTasks.Count > 0 && (Content.ExecutionState == ExecutionState.Prepared || Content.ExecutionState == ExecutionState.Paused) && !Content.IsProgressing;
-        pauseButton.Enabled = Content.IsControllable && Content.ExecutionState == ExecutionState.Started && !Content.IsProgressing;
-        stopButton.Enabled = Content.IsControllable && (Content.ExecutionState == ExecutionState.Started || Content.ExecutionState == ExecutionState.Paused) && !Content.IsProgressing;
-      }
-    }
-    #endregion
-
-    #region Drag & Drop
-    private void jobsTreeView_DragOver(object sender, DragEventArgs e) {
-      jobsTreeView_DragEnter(sender, e);
-    }
-
-    private void jobsTreeView_DragEnter(object sender, DragEventArgs e) {
-      e.Effect = DragDropEffects.None;
-      var obj = (IDeepCloneable)e.Data.GetData(Constants.DragDropDataFormat);
-
-      Type objType = obj.GetType();
-      if (ItemTask.IsTypeSupported(objType)) {
-        if (Content.Id != Guid.Empty) e.Effect = DragDropEffects.None;
-        else if ((e.KeyState & 32) == 32) e.Effect = DragDropEffects.Link;  // ALT key
-        else if (e.AllowedEffect.HasFlag(DragDropEffects.Copy)) e.Effect = DragDropEffects.Copy;
-      }
-    }
-
-    private void jobsTreeView_DragDrop(object sender, DragEventArgs e) {
-      if (e.Effect != DragDropEffects.None) {
-        var obj = (IItem)e.Data.GetData(Constants.DragDropDataFormat);
-
-        IItem newObj = null;
-        if (e.Effect.HasFlag(DragDropEffects.Copy)) {
-          newObj = (IItem)obj.Clone();
-        } else {
-          newObj = obj;
-        }
-
-        //IOptimizer and IExecutables need some special care
-        if (newObj is IOptimizer) {
-          ((IOptimizer)newObj).Runs.Clear();
-        }
-        if (newObj is IExecutable) {
-          IExecutable exec = (IExecutable)newObj;
-          if (exec.ExecutionState != ExecutionState.Prepared) {
-            exec.Prepare();
-          }
-        }
-
-        ItemTask hiveTask = ItemTask.GetItemTaskForItem(newObj);
-        Content.HiveTasks.Add(hiveTask.CreateHiveTask());
-      }
-    }
-    #endregion
-
-    private void tabControl_SelectedIndexChanged(object sender, EventArgs e) {
-      if (tabControl.SelectedTab == permissionTabPage) {
-        if (!Content.IsSharable) {
-          MessageBox.Show("Unable to load permissions. You have insufficient access privileges.", "HeuristicLab Hive Job Manager", MessageBoxButtons.OK, MessageBoxIcon.Information);
-          tabControl.SelectedTab = tasksTabPage;
-        }
-      }
-    }
-
-    private RunCollection GetAllRunsFromJob(RefreshableJob job) {
-      if (job != null) {
-        RunCollection runs = new RunCollection() { OptimizerName = job.ItemName };
-
-        foreach (HiveTask subTask in job.HiveTasks) {
-          if (subTask is OptimizerHiveTask) {
-            OptimizerHiveTask ohTask = subTask as OptimizerHiveTask;
-            ohTask.ExecuteReadActionOnItemTask(new Action(delegate() {
-              runs.AddRange(ohTask.ItemTask.Item.Runs);
-            }));
-          }
-        }
-        return runs;
-      } else {
-        return null;
-      }
+      UpdateSelectorDialog();
+    }
+
+    private void updateButton_Click(object sender, EventArgs e) {
+      if (Content.ExecutionState == ExecutionState.Stopped) {
+        MessageBox.Show("Job cannot be updated once it stopped.", "HeuristicLab Hive Job Manager", MessageBoxButtons.OK, MessageBoxIcon.Information);
+        return;
+      }
+
+      var invoker = new Action<RefreshableJob>(HiveClient.UpdateJob);
+      invoker.BeginInvoke(Content, (ar) => {
+        try {
+          invoker.EndInvoke(ar);
+        } catch (Exception ex) {
+          ThreadPool.QueueUserWorkItem(delegate (object exception) { ErrorHandling.ShowErrorDialog(this, (Exception)exception); }, ex);
+        }
+      }, null);
+      UpdateSelectorDialog();
     }
 
@@ -526,4 +567,113 @@
       SetEnabledStateOfControls();
     }
+
+    private void refreshPermissionsButton_Click(object sender, EventArgs e) {
+      if (this.Content.Job.Id == Guid.Empty) {
+        MessageBox.Show("You have to upload the Job first before you can share it.", "HeuristicLab Hive Job Manager", MessageBoxButtons.OK, MessageBoxIcon.Information);
+      } else {
+        hiveExperimentPermissionListView.Content = HiveClient.GetJobPermissions(this.Content.Job.Id);
+      }
+    }
+    #endregion
+
+    #region Helpers
+    private void SetEnabledStateOfExecutableButtons() {
+      if (Content == null) {
+        startButton.Enabled = pauseButton.Enabled = stopButton.Enabled = false;
+      } else {
+        startButton.Enabled = Content.IsControllable && Content.HiveTasks != null && Content.HiveTasks.Count > 0 
+          && Content.Job.ProjectId != Guid.Empty && Content.Job.ResourceIds != null  && Content.Job.ResourceIds.Any() 
+          && (Content.ExecutionState == ExecutionState.Prepared || Content.ExecutionState == ExecutionState.Paused) && !Content.IsProgressing;
+        pauseButton.Enabled = Content.IsControllable && Content.ExecutionState == ExecutionState.Started && !Content.IsProgressing;
+        stopButton.Enabled = Content.IsControllable && (Content.ExecutionState == ExecutionState.Started || Content.ExecutionState == ExecutionState.Paused) && !Content.IsProgressing;
+      }
+    }
+   
+    private Project GetProject(Guid projectId) {
+      return HiveServiceLocator.Instance.CallHiveService(s => s.GetProject(projectId));
+    }
+
+    private void UpdateSelectorDialog() {
+      if(hiveResourceSelectorDialog != null) {
+        hiveResourceSelectorDialog = null;
+        //hiveResourceSelectorDialog.JobId = Content.Job.Id;
+        //hiveResourceSelectorDialog.SelectedProjectId = Content.Job.ProjectId;
+        //hiveResourceSelectorDialog.SelectedResourceIds = Content.Job.ResourceIds;
+      }
+    }
+    #endregion
+
+    #region Drag & Drop
+    private void jobsTreeView_DragOver(object sender, DragEventArgs e) {
+      jobsTreeView_DragEnter(sender, e);
+    }
+
+    private void jobsTreeView_DragEnter(object sender, DragEventArgs e) {
+      e.Effect = DragDropEffects.None;
+      var obj = (IDeepCloneable)e.Data.GetData(Constants.DragDropDataFormat);
+
+      Type objType = obj.GetType();
+      if (ItemTask.IsTypeSupported(objType)) {
+        if (Content.Id != Guid.Empty) e.Effect = DragDropEffects.None;
+        else if ((e.KeyState & 32) == 32) e.Effect = DragDropEffects.Link;  // ALT key
+        else if (e.AllowedEffect.HasFlag(DragDropEffects.Copy)) e.Effect = DragDropEffects.Copy;
+      }
+    }
+
+    private void jobsTreeView_DragDrop(object sender, DragEventArgs e) {
+      if (e.Effect != DragDropEffects.None) {
+        var obj = (IItem)e.Data.GetData(Constants.DragDropDataFormat);
+
+        IItem newObj = null;
+        if (e.Effect.HasFlag(DragDropEffects.Copy)) {
+          newObj = (IItem)obj.Clone();
+        } else {
+          newObj = obj;
+        }
+
+        //IOptimizer and IExecutables need some special care
+        if (newObj is IOptimizer) {
+          ((IOptimizer)newObj).Runs.Clear();
+        }
+        if (newObj is IExecutable) {
+          IExecutable exec = (IExecutable)newObj;
+          if (exec.ExecutionState != ExecutionState.Prepared) {
+            exec.Prepare();
+          }
+        }
+
+        ItemTask hiveTask = ItemTask.GetItemTaskForItem(newObj);
+        Content.HiveTasks.Add(hiveTask.CreateHiveTask());
+      }
+    }
+    #endregion
+
+    private void tabControl_SelectedIndexChanged(object sender, EventArgs e) {
+      if (tabControl.SelectedTab == permissionTabPage) {
+        if (!Content.IsSharable) {
+          MessageBox.Show("Unable to load permissions. You have insufficient access privileges.", "HeuristicLab Hive Job Manager", MessageBoxButtons.OK, MessageBoxIcon.Information);
+          tabControl.SelectedTab = tasksTabPage;
+        }
+      }
+    }
+
+    private RunCollection GetAllRunsFromJob(RefreshableJob job) {
+      if (job != null) {
+        RunCollection runs = new RunCollection() { OptimizerName = job.ItemName };
+
+        foreach (HiveTask subTask in job.HiveTasks) {
+          if (subTask is OptimizerHiveTask) {
+            OptimizerHiveTask ohTask = subTask as OptimizerHiveTask;
+            ohTask.ExecuteReadActionOnItemTask(new Action(delegate () {
+              runs.AddRange(ohTask.ItemTask.Item.Runs);
+            }));
+          }
+        }
+        return runs;
+      } else {
+        return null;
+      }
+    }
+
   }
 }
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/Extensions/FixedNumericUpDown.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/Extensions/FixedNumericUpDown.cs	(revision 16240)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/Extensions/FixedNumericUpDown.cs	(revision 16240)
@@ -0,0 +1,40 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Windows.Forms;
+
+namespace HeuristicLab.Clients.Hive.Views.Extensions {
+  // Bugfix for NumericUpDown to disable arrow controls correctly
+  // cf. https://www.codeproject.com/Articles/16321/NumericUpDown-with-correct-read-only-behavior
+  public class FixedNumericUpDown : NumericUpDown {
+    public override void DownButton() {
+      if (ReadOnly)
+        return;
+      base.DownButton();
+    }
+
+    public override void UpButton() {
+      if (ReadOnly)
+        return;
+      base.UpButton();
+    }
+  }
+}
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HeuristicLab.Clients.Hive.Views-3.3.csproj
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HeuristicLab.Clients.Hive.Views-3.3.csproj	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HeuristicLab.Clients.Hive.Views-3.3.csproj	(revision 16240)
@@ -101,4 +101,7 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Extensions\FixedNumericUpDown.cs">
+      <SubType>Component</SubType>
+    </Compile>
     <Compile Include="HiveInformationDialog.cs">
       <SubType>Form</SubType>
@@ -168,4 +171,7 @@
     <Compile Include="StateLog\StateLogView.designer.cs">
       <DependentUpon>StateLogView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="TreeView\NoDoubleClickTreeView.cs">
+      <SubType>Component</SubType>
     </Compile>
     <None Include="Plugin.cs.frame" />
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HiveItemView.Designer.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HiveItemView.Designer.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HiveItemView.Designer.cs	(revision 16240)
@@ -52,5 +52,5 @@
       // storeButton
       // 
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(0, 0);
       this.storeButton.Name = "storeButton";
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.cs	(revision 16240)
@@ -211,4 +211,12 @@
       }
     }
+
+    private void coresNeededComboBox_SelectedIndexChanged(object sender, EventArgs e) {
+      if (Content != null && Content.Task != null) {
+        int cores;
+        if (int.TryParse(coresNeededComboBox.SelectedItem.ToString(), out cores) && Content.Task.CoresNeeded != cores)
+          Content.Task.CoresNeeded = cores;
+      }
+    }
   }
 }
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.designer.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.designer.cs	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/HiveTasks/HiveTaskView.designer.cs	(revision 16240)
@@ -292,9 +292,14 @@
             "2",
             "3",
-            "4"});
+            "4",
+            "6",
+            "8",
+            "10",
+            "12"});
       this.coresNeededComboBox.Location = new System.Drawing.Point(134, 13);
       this.coresNeededComboBox.Name = "coresNeededComboBox";
       this.coresNeededComboBox.Size = new System.Drawing.Size(134, 21);
       this.coresNeededComboBox.TabIndex = 41;
+      this.coresNeededComboBox.SelectedIndexChanged += new System.EventHandler(this.coresNeededComboBox_SelectedIndexChanged);
       // 
       // memoryNeededLabel
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/TreeView/NoDoubleClickTreeView.cs
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/TreeView/NoDoubleClickTreeView.cs	(revision 16240)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive.Views/3.3/TreeView/NoDoubleClickTreeView.cs	(revision 16240)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Clients.Hive.Views.TreeView {
+  // Workaround for a well-known bug in TreeView
+  // cf. https://stackoverflow.com/questions/6130297/c-how-to-avoid-treenode-check-from-happening-on-a-double-click-event
+  public class NoDoubleClickTreeView : System.Windows.Forms.TreeView {
+    protected override void WndProc(ref Message m) {
+      // Suppress WM_LBUTTONDBLCLK
+      if (m.Msg == 0x203) { m.Result = IntPtr.Zero; } else base.WndProc(ref m);
+    }
+  }
+}
Index: /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj
===================================================================
--- /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 16239)
+++ /branches/2915-AbsoluteSymbol/HeuristicLab.Clients.Hive/3.3/HeuristicLab.Clients.Hive-3.3.csproj	(revision 16240)
@@ -125,4 +125,7 @@
     <Compile Include="HiveAdminClient.cs" />
     <Compile Include="HiveClient.cs" />
+    <Compile Include="ServiceClients\AssignedJobResource.cs" />
+    <Compile Include="ServiceClients\AssignedProjectResource.cs" />
+    <Compile Include="ServiceClients\Project.cs" />
     <Compile Include="ServiceClients\UserPriority.cs" />
     <Compile Include="ServiceClients\ResourcePermission.cs" />
@@ -194,4 +197,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Clients.Access\3.3\HeuristicLab.Clients.Access-3.3.csproj">
+      <Project>{494F87F4-0F25-4D33-A382-10CDB2174D48}</Project>
+      <Name>HeuristicLab.Clients.Access-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Clients.Common\3.3\HeuristicLab.Clients.Common-3.3.csproj">
       <Project>{730A9104-D4D1-4360-966B-E49B7571DDA3}</Project>
